// half-case for USB3.0-SATA + 25x15 DC-DC converter

base_h = 2.4;
dcdc_h = 1.4;
usb_h = 1.9;

// assembly
color([0, 0.8, 0]) {
    cube(size=[42, 30, 1.5]);
    translate([-2-15, 2.5, -(5-usb_h)]) cube(size=[15, 25, dcdc_h]);
    translate([0.5, 30-14+2, -(5-usb_h)]) cube(size=[11, 14, 10]);
    translate([42-13.5-12, 30, -(5-usb_h)]) cube(size=[12, 2, 8]);
    translate([42-13.5-12/2, 40, -(5-usb_h)+8/2]) rotate([90, 0, 0]) cylinder(r=6.5/2, $fn=32, h=8);
    translate([42-13.5-12/2, 30, -(5-usb_h)+8/2]) rotate([90, 0, 0]) cylinder(r=5/2, $fn=32, h=3);
    translate([0.5+9/2, 40, 10/2-(5-usb_h)]) rotate([90, 0, 0]) cylinder(r=9/2, $fn=32, h=8);
}
difference()
{
    union()
    {
        // part 2
        color([1, 0.5, 0.5]) {
            translate([-2-15, 0, usb_h+5.2]) cube(size=[42+2+15, 30+2*2, 1]);
            translate([-2-15+1.2, 0, usb_h+5.2+1]) cube(size=[42+2+15-2.4, 30+2*2, 1]);
            translate([-2-15+1.2, 30+2, usb_h-5+8/2]) cube(size=[42+2+15-2.4, 2, 5.2+5-8/2]);
            translate([-2-15, 30+2, usb_h-5+8/2]) cube(size=[42+2+15, 2, 5.2+5-8/2-1]);
        }
        // part 1
        union() {
            translate([-2*2-15, 0, -(5-usb_h+base_h)]) cube(size=[42+2*3+15, 30+2*2, base_h]);

            translate([-2*2-15, 0, -(5-usb_h+base_h)]) cube(size=[2, 30+2*2, 5+base_h+5.2+2]);
            translate([-2*2-15, 0, usb_h+5.2+1]) cube(size=[3, 30+2*2, 1]);
            translate([-2*2-15, 0, usb_h+5.2-1]) cube(size=[3, 30+2*2, 1]);
            translate([-2*2-15, 0, -(5-usb_h+base_h)]) cube(size=[2, 30+2*2, 5+base_h+5.2+2]);
            translate([-2*2-15, 0, -(5-usb_h+base_h)]) cube(size=[2+0.5, 30+2*2, base_h+dcdc_h+2]);
            translate([-2-0.5, 0, -(5-usb_h+base_h)]) cube(size=[2+0.5, 30+2*2, base_h+dcdc_h+2]);

            translate([-2, 5, -(5-usb_h+base_h)]) cube(size=[2+1, 11, 5+base_h+2]);
            translate([-2, 0, -(5-usb_h+base_h)]) cube(size=[2, 30+2, 5+base_h+2]);

            translate([42-1, 5, -(5-usb_h+base_h)]) cube(size=[2+1, 30-5, 5+base_h+2]);
            translate([42, 0, -(5-usb_h+base_h)]) cube(size=[2, 30+2*2, 5+base_h+5.2+2]);
            translate([42-1, 0, usb_h+5.2+1]) cube(size=[2+1, 30+2*2, 1]);
            translate([42-1, 0, usb_h+5.2-1]) cube(size=[2+1, 30+2*2, 1]);

            translate([42-13.5-12-2, 30-2, -(5-usb_h+base_h)]) cube(size=[12+2*2, 6, 3]);
            translate([-2*2-15, 30+2, -(5-usb_h)]) cube(size=[42+2*3+15, 2, 8/2]);

            translate([42-13, 30, -(5-usb_h+base_h)]) cube(size=[13, 2, 5+base_h+2]);
            translate([42-13.5-12-4.5, 30, -(5-usb_h+base_h)]) cube(size=[4, 2, 5+base_h+2]);
        }
    }
    translate([0, -1, 0]) cube(size=[42, 30+1, usb_h]);
    translate([42/2, 30/2, -5-1]) cylinder(r=1, h=base_h+2, $fn=32, center=false);
    translate([-2-15.25, -2, -(5-usb_h)]) cube(size=[15.5, 30+2+2, dcdc_h]);
    translate([42-13.5-12, 30, -(5-usb_h)]) cube(size=[12, 2, 8]);
    translate([42-13.5-12/2, 40-1, -(5-usb_h)+8/2]) rotate([90, 0, 0]) cylinder(r=6.5/2, $fn=32, h=8+1);
    translate([42-13.5-12/2, 30, -(5-usb_h)+8/2]) rotate([90, 0, 0]) cylinder(r=5/2, $fn=32, h=3);
    translate([0.5+9/2, 40-1, 10/2-(5-usb_h)]) rotate([90, 0, 0]) cylinder(r=9/2, $fn=32, h=8+1);
}
